#region Copyright Syncfusion Inc. 2001 - 2007
//
//  Copyright Syncfusion Inc. 2001 - 2007. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;

namespace EssentialPDFSamples
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public class Form1 : System.Windows.Forms.Form
    {
        # region Private Members
        private System.Windows.Forms.Button button1;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.PictureBox pictureBox1;
        
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;
        # endregion

        # region Constructor
        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            Application.EnableVisualStyles();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.button1 = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.BackColor = System.Drawing.Color.Transparent;
            this.button1.FlatAppearance.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(192)))), ((int)(((byte)(128)))));
            this.button1.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(224)))), ((int)(((byte)(192)))));
            this.button1.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
            this.button1.Image = ((System.Drawing.Image)(resources.GetObject("button1.Image")));
            this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.button1.Location = new System.Drawing.Point(256, 160);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 24);
            this.button1.TabIndex = 0;
            this.button1.Text = "Span ";
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(0)))), ((int)(((byte)(64)))));
            this.label1.Location = new System.Drawing.Point(0, 120);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(373, 76);
            this.label1.TabIndex = 1;
            this.label1.Text = "Click the button to view an PDF document generated by Essential PDF.  Please note" +
    " that Adobe Reader or its equivalent is required to view the resultant document." +
    "";
            // 
            // pictureBox1
            // 
            this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(0, 0);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(373, 89);
            this.pictureBox1.TabIndex = 24;
            this.pictureBox1.TabStop = false;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(373, 196);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.pictureBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Hello World";
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }
        #endregion

        # region Events
        private void button1_Click(object sender, System.EventArgs e)
        {
            //Create new Document
            PdfDocument document = new PdfDocument();

            //Add new page to the document
            PdfPage page = document.Pages.Add();

            //Create a PdfGrid
            PdfGrid pdfGrid = new PdfGrid();

            //Adding 4 columns to the Grid
            pdfGrid.Columns.Add(5);

           

            //Adding few rows to the Grid
            for (int i = 0; i < 99; i++)
            {
                var row = pdfGrid.Rows.Add();
                row.Height = 15f;
                for (int j = 0; j < 5; j++)
                {
                    row.Cells[j].Value = String.Format("R {0} C {1}", i, j);

                }
            }

            //Spanning the rows and  columns 1,2,3,4,5
            for (int i = 3; i < 99; i+=6)
            {
                if (i + 3 > 99)
                {
                    pdfGrid.Rows[i].Cells[1].RowSpan = 99 - i;
                    pdfGrid.Rows[i].Cells[2].RowSpan = 99-i;
                    pdfGrid.Rows[i].Cells[3].RowSpan = 99-i;
                }
                else
                {
                    pdfGrid.Rows[i].Cells[1].RowSpan = 3;
                    pdfGrid.Rows[i].Cells[2].RowSpan = 3;
                    pdfGrid.Rows[i].Cells[3].RowSpan = 3;
                }
                    
               
            }

            //create the cell style 
            PdfGridCellStyle style=new PdfGridCellStyle();
            
            //apply the brush 
            style.BackgroundBrush=PdfBrushes.Green;

            //Create the row style 
            PdfGridRowStyle rowStyle=new PdfGridRowStyle();

            //Apply the brush
            rowStyle.BackgroundBrush=PdfBrushes.LightBlue;

            //Apply the span for column 0,1 & 4
            for (int i = 0; i < 99; i++)
            {
                for(int j=0;j<pdfGrid.Rows[i].Cells.Count;j++)
                {
                    if (i % 3 == 0)
                    {
                        pdfGrid.Rows[i].Cells[0].RowSpan = 3;
                       
                        if (i % 6 == 0)
                            pdfGrid.Rows[i].Cells[0].Style = style;
                    }
                   

                    if (i % 6 == 0)
                    {
                        pdfGrid.Rows[i].Cells[1].ColumnSpan = 3;
                       
                       
                        pdfGrid.Rows[i + 1].Style = rowStyle;
                        pdfGrid.Rows[i + 2].Style = rowStyle;
                        

                        if(i+6 < 99)
                        pdfGrid.Rows[i].Cells[4].RowSpan = 6;

                        if (i + 6 > 99)
                        {
                            //Apply the row span for remianing columns
                            pdfGrid.Rows[i].Cells[4].RowSpan=99-i;
                        }
                    }
                   
                }
            }


            //Span the cells in the 6th alternates 
            for (int i = 1; i < 99; i+=6)
            {

                pdfGrid.Rows[i].Cells[1].RowSpan = 2;
                pdfGrid.Rows[i].Cells[2].RowSpan = 2;
                pdfGrid.Rows[i].Cells[3].RowSpan = 2;
                
            }

            //Creating layout format
            PdfGridLayoutFormat format = new PdfGridLayoutFormat
            {
                Layout = PdfLayoutType.Paginate,
                Break = PdfLayoutBreakType.FitElement
            };

            //Drawing the grid to the PDF Page
            pdfGrid.Draw(page, new PointF(), format);

            //Saving the Pdf document
            document.Save("Sample.pdf");
            document.Close();

            //Message box confirmation to view the created PDF document.
            if (MessageBox.Show("Do you want to view the PDF file?", "PDF File Created",
                MessageBoxButtons.YesNo, MessageBoxIcon.Information)
                == DialogResult.Yes)
            {
                //Launching the PDF file using the default Application.[Acrobat Reader]
                System.Diagnostics.Process.Start("Sample.pdf");
                this.Close();
            }
            else
            {
                // Exit
                this.Close();
            }
        }

        # endregion

        private void button2_Click(object sender, EventArgs e)
        {
           

        }
    }
}